/*
 * Copyright 2009-2009 the Fess Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package jp.sf.fess.db.cbean.bs;

import java.util.Map;

import jp.sf.fess.db.allcommon.DBFluteConfig;
import jp.sf.fess.db.allcommon.DBMetaInstanceHandler;
import jp.sf.fess.db.allcommon.ImplementedSqlClauseCreator;
import jp.sf.fess.db.cbean.RequestHeaderCB;
import jp.sf.fess.db.cbean.WebAuthenticationCB;
import jp.sf.fess.db.cbean.WebConfigToBrowserTypeMappingCB;
import jp.sf.fess.db.cbean.WebConfigToLabelTypeMappingCB;
import jp.sf.fess.db.cbean.WebConfigToRoleTypeMappingCB;
import jp.sf.fess.db.cbean.WebCrawlingConfigCB;
import jp.sf.fess.db.cbean.cq.WebCrawlingConfigCQ;

import org.seasar.dbflute.cbean.AbstractConditionBean;
import org.seasar.dbflute.cbean.ConditionBean;
import org.seasar.dbflute.cbean.ConditionQuery;
import org.seasar.dbflute.cbean.SubQuery;
import org.seasar.dbflute.cbean.UnionQuery;
import org.seasar.dbflute.cbean.sqlclause.SqlClause;
import org.seasar.dbflute.dbmeta.DBMetaProvider;

/**
 * The base condition-bean of WEB_CRAWLING_CONFIG.
 * @author DBFlute(AutoGenerator)
 */
public class BsWebCrawlingConfigCB extends AbstractConditionBean {

    // ===================================================================================
    //                                                                           Attribute
    //                                                                           =========
    private final DBMetaProvider _dbmetaProvider = new DBMetaInstanceHandler();

    protected WebCrawlingConfigCQ _conditionQuery;

    // ===================================================================================
    //                                                                           SqlClause
    //                                                                           =========
    @Override
    protected SqlClause createSqlClause() {
        return new ImplementedSqlClauseCreator().createSqlClause(this);
    }

    // ===================================================================================
    //                                                                     DBMeta Provider
    //                                                                     ===============
    @Override
    protected DBMetaProvider getDBMetaProvider() {
        return _dbmetaProvider;
    }

    // ===================================================================================
    //                                                                          Table Name
    //                                                                          ==========
    public String getTableDbName() {
        return "WEB_CRAWLING_CONFIG";
    }

    public String getTableSqlName() {
        return "WEB_CRAWLING_CONFIG";
    }

    // ===================================================================================
    //                                                                      PrimaryKey Map
    //                                                                      ==============
    public void acceptPrimaryKeyMap(Map<String, ? extends Object> primaryKeyMap) {
        assertPrimaryKeyMap(primaryKeyMap);
        {
            Object obj = primaryKeyMap.get("ID");
            if (obj instanceof Long) {
                query().setId_Equal((Long) obj);
            } else {
                query().setId_Equal(new Long((String) obj));
            }
        }

    }

    // ===================================================================================
    //                                                                     OrderBy Setting
    //                                                                     ===============
    public ConditionBean addOrderBy_PK_Asc() {
        query().addOrderBy_Id_Asc();
        return this;
    }

    public ConditionBean addOrderBy_PK_Desc() {
        query().addOrderBy_Id_Desc();
        return this;
    }

    // ===================================================================================
    //                                                                               Query
    //                                                                               =====
    public WebCrawlingConfigCQ query() {
        return getConditionQuery();
    }

    public WebCrawlingConfigCQ getConditionQuery() {
        if (_conditionQuery == null) {
            _conditionQuery = new WebCrawlingConfigCQ(null, getSqlClause(),
                    getSqlClause().getLocalTableAliasName(), 0);
        }
        return _conditionQuery;
    }

    /**
     * {@inheritDoc}
     */
    public ConditionQuery localCQ() {
        return getConditionQuery();
    }

    // ===================================================================================
    //                                                                               Union
    //                                                                               =====
    /**
     * Set up 'union'.
     * <pre>
     * cb.query().union(new UnionQuery&lt;WebCrawlingConfigCB&gt;() {
     *     public void query(WebCrawlingConfigCB unionCB) {
     *         unionCB.query().setXxx...
     *     }
     * });
     * </pre>
     * @param unionQuery The query of 'union'. (NotNull)
     */
    public void union(UnionQuery<WebCrawlingConfigCB> unionQuery) {
        final WebCrawlingConfigCB cb = new WebCrawlingConfigCB();
        cb.xsetupForUnion();
        unionQuery.query(cb);
        final WebCrawlingConfigCQ cq = cb.query();
        query().xsetUnionQuery(cq);
    }

    /**
     * Set up 'union all'.
     * <pre>
     * cb.query().unionAll(new UnionQuery&lt;WebCrawlingConfigCB&gt;() {
     *     public void query(WebCrawlingConfigCB unionCB) {
     *         unionCB.query().setXxx...
     *     }
     * });
     * </pre>
     * @param unionQuery The query of 'union'. (NotNull)
     */
    public void unionAll(UnionQuery<WebCrawlingConfigCB> unionQuery) {
        final WebCrawlingConfigCB cb = new WebCrawlingConfigCB();
        cb.xsetupForUnion();
        unionQuery.query(cb);
        final WebCrawlingConfigCQ cq = cb.query();
        query().xsetUnionAllQuery(cq);
    }

    public boolean hasUnionQueryOrUnionAllQuery() {
        return query().hasUnionQueryOrUnionAllQuery();
    }

    // ===================================================================================
    //                                                                        Setup Select
    //                                                                        ============

    // [DBFlute-0.7.4]
    // ===================================================================================
    //                                                                             Specify
    //                                                                             =======
    protected Specification _specification;

    public Specification specify() {
        if (_specification == null) {
            _specification = new Specification(this,
                    new SpQyCall<WebCrawlingConfigCQ>() {
                        public boolean has() {
                            return true;
                        }

                        public WebCrawlingConfigCQ qy() {
                            return query();
                        }
                    }, _forDerivedReferrer, _forScalarSelect,
                    _forScalarSubQuery, getDBMetaProvider());
        }
        return _specification;
    }

    public static class Specification extends
            AbstractSpecification<WebCrawlingConfigCQ> {
        protected SpQyCall<WebCrawlingConfigCQ> _myQyCall;

        public Specification(ConditionBean baseCB,
                SpQyCall<WebCrawlingConfigCQ> qyCall,
                boolean forDeriveReferrer, boolean forScalarSelect,
                boolean forScalarSubQuery, DBMetaProvider dbmetaProvider) {
            super(baseCB, qyCall, forDeriveReferrer, forScalarSelect,
                    forScalarSubQuery, dbmetaProvider);
            _myQyCall = qyCall;
        }

        public void columnId() {
            doColumn("ID");
        }

        public void columnName() {
            doColumn("NAME");
        }

        public void columnUrls() {
            doColumn("URLS");
        }

        public void columnIncludedUrls() {
            doColumn("INCLUDED_URLS");
        }

        public void columnExcludedUrls() {
            doColumn("EXCLUDED_URLS");
        }

        public void columnDepth() {
            doColumn("DEPTH");
        }

        public void columnMaxAccessCount() {
            doColumn("MAX_ACCESS_COUNT");
        }

        public void columnUserAgent() {
            doColumn("USER_AGENT");
        }

        public void columnNumOfThread() {
            doColumn("NUM_OF_THREAD");
        }

        public void columnIntervalTime() {
            doColumn("INTERVAL_TIME");
        }

        public void columnAvailable() {
            doColumn("AVAILABLE");
        }

        public void columnSortOrder() {
            doColumn("SORT_ORDER");
        }

        public void columnCreatedBy() {
            doColumn("CREATED_BY");
        }

        public void columnCreatedTime() {
            doColumn("CREATED_TIME");
        }

        public void columnUpdatedBy() {
            doColumn("UPDATED_BY");
        }

        public void columnUpdatedTime() {
            doColumn("UPDATED_TIME");
        }

        public void columnDeletedBy() {
            doColumn("DELETED_BY");
        }

        public void columnDeletedTime() {
            doColumn("DELETED_TIME");
        }

        public void columnVersionNo() {
            doColumn("VERSION_NO");
        }

        protected void doSpecifyRequiredColumn() {
            columnId(); // PK
        }

        protected String getTableDbName() {
            return "WEB_CRAWLING_CONFIG";
        }

        public RAFunction<RequestHeaderCB, WebCrawlingConfigCQ> derivedRequestHeaderList() {
            return new RAFunction<RequestHeaderCB, WebCrawlingConfigCQ>(
                    _baseCB, _myQyCall.qy(),
                    new RAQSetupper<RequestHeaderCB, WebCrawlingConfigCQ>() {
                        public void setup(String function,
                                SubQuery<RequestHeaderCB> subQuery,
                                WebCrawlingConfigCQ cq, String aliasName) {
                            cq.xsderiveRequestHeaderList(function, subQuery,
                                    aliasName);
                        }
                    }, _dbmetaProvider);
        }

        public RAFunction<WebAuthenticationCB, WebCrawlingConfigCQ> derivedWebAuthenticationList() {
            return new RAFunction<WebAuthenticationCB, WebCrawlingConfigCQ>(
                    _baseCB,
                    _myQyCall.qy(),
                    new RAQSetupper<WebAuthenticationCB, WebCrawlingConfigCQ>() {
                        public void setup(String function,
                                SubQuery<WebAuthenticationCB> subQuery,
                                WebCrawlingConfigCQ cq, String aliasName) {
                            cq.xsderiveWebAuthenticationList(function,
                                    subQuery, aliasName);
                        }
                    }, _dbmetaProvider);
        }

        public RAFunction<WebConfigToBrowserTypeMappingCB, WebCrawlingConfigCQ> derivedWebConfigToBrowserTypeMappingList() {
            return new RAFunction<WebConfigToBrowserTypeMappingCB, WebCrawlingConfigCQ>(
                    _baseCB,
                    _myQyCall.qy(),
                    new RAQSetupper<WebConfigToBrowserTypeMappingCB, WebCrawlingConfigCQ>() {
                        public void setup(
                                String function,
                                SubQuery<WebConfigToBrowserTypeMappingCB> subQuery,
                                WebCrawlingConfigCQ cq, String aliasName) {
                            cq.xsderiveWebConfigToBrowserTypeMappingList(
                                    function, subQuery, aliasName);
                        }
                    }, _dbmetaProvider);
        }

        public RAFunction<WebConfigToLabelTypeMappingCB, WebCrawlingConfigCQ> derivedWebConfigToLabelTypeMappingList() {
            return new RAFunction<WebConfigToLabelTypeMappingCB, WebCrawlingConfigCQ>(
                    _baseCB,
                    _myQyCall.qy(),
                    new RAQSetupper<WebConfigToLabelTypeMappingCB, WebCrawlingConfigCQ>() {
                        public void setup(
                                String function,
                                SubQuery<WebConfigToLabelTypeMappingCB> subQuery,
                                WebCrawlingConfigCQ cq, String aliasName) {
                            cq.xsderiveWebConfigToLabelTypeMappingList(
                                    function, subQuery, aliasName);
                        }
                    }, _dbmetaProvider);
        }

        public RAFunction<WebConfigToRoleTypeMappingCB, WebCrawlingConfigCQ> derivedWebConfigToRoleTypeMappingList() {
            return new RAFunction<WebConfigToRoleTypeMappingCB, WebCrawlingConfigCQ>(
                    _baseCB,
                    _myQyCall.qy(),
                    new RAQSetupper<WebConfigToRoleTypeMappingCB, WebCrawlingConfigCQ>() {
                        public void setup(
                                String function,
                                SubQuery<WebConfigToRoleTypeMappingCB> subQuery,
                                WebCrawlingConfigCQ cq, String aliasName) {
                            cq.xsderiveWebConfigToRoleTypeMappingList(function,
                                    subQuery, aliasName);
                        }
                    }, _dbmetaProvider);
        }
    }

    // ===================================================================================
    //                                                                         Display SQL
    //                                                                         ===========
    @Override
    protected String getLogDateFormat() {
        return DBFluteConfig.getInstance().getLogDateFormat();
    }

    @Override
    protected String getLogTimestampFormat() {
        return DBFluteConfig.getInstance().getLogTimestampFormat();
    }

    // ===================================================================================
    //                                                                            Internal
    //                                                                            ========
    // Very Internal (for Suppressing Warn about 'Not Use Import')
    protected String getConditionBeanClassNameInternally() {
        return WebCrawlingConfigCB.class.getName();
    }

    protected String getConditionQueryClassNameInternally() {
        return WebCrawlingConfigCQ.class.getName();
    }

    protected String getSubQueryClassNameInternally() {
        return SubQuery.class.getName();
    }
}
